| Earth Observation Mission CFI Software Pointing Software User Manual for JAVA |

Public Member Functions | Public Attributes

# EECFI.Target Class Reference

Class for target calculations. More...

Inheritance diagram for EECFI.Target:

List of all members.

## Public Member Functions
| Target (final Attitude att, final DemId dem, final AtmosId atmos) throws CfiError
| Class constructor.
native void | targetInter (final SatId satId, long deriv, long interFlag, double losAz, double losEl, double geodAlt, double losAzRate, double losElRate, long iray, double freq) throws CfiError
| Compute the first or the second intersection point of the line of sight from the satellite with a surface located at a certanin geodetic altitude over the Earth.
native void | targetTravelTime (final SatId satId, long deriv, double losAz, double losEl, double travelTime, double losAzRate, double losElRate, double travelTimeRate, long iray, double freq) throws CfiError
| It computes the point of the line or sight from the satellite at a given travel time along the line of sight.
native void | targetGroundRange (final SatId satId, long deriv, double losAz, double losEl, double geodAlt, double distance, double losAzRate, double losElRate) throws CfiError
| It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth, that lays on the plane defined by the satellite position, the nadir and a reference point.
native void | targetIncidenceAngle (final SatId satId, long deriv, double losAz, double incidenceAngle, double geodAlt, double losAzRate) throws CfiError
| It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth and that is seen from the satellite on a line of sight that forms a certain azimuth angle in the selected Attitude Frame and that intersects that surface with a certain incidence angle.
native void | targetRange (final SatId satId, long deriv, double losAz, double range, double geodAlt, double losAzRate, double rangeRate) throws CfiError
| It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth, that is seen from the satellite on a line of sight that forms a certain azimuth angle in the selected Attitude Frame, and that is at a certain range or slant-range from the satellite.
native void | targetRangeRate (final SatId satId, long deriv, double efRangeRate, double range, double geodAlt, double efRangeRateRate, double rangeRate) throws CfiError
| It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth, that is at a certain range from the satellite, and whose associatedEarth-fixed target has a certain range-rate value.
native void | targetTangent (final SatId satId, long deriv, double losAz, double losEl, double losAzRate, double losElRate, long iray, double freq) throws CfiError
| It computes the location of the tangent point over the Earth that is located on the line of sight defined by an elevation and azimuth angles expressed in the selected Attitude Frame.
native void | targetAltitude (final SatId satId, long deriv, double losAz, double geodAlt, double losAzRate, long iray, double freq) throws CfiError
| It computes the location of the tangent point over the Earth that is located on a surface at a certain geodetic altitude over the Earth and that is on a line of sight that forms a certain azimuth angle in the selected Attitude Frame.
native void | targetStar (final SatId satId, long deriv, double starRa, double starDec, double starRaRate, double starDecRate, long iray, double freq) throws CfiError
| It computes the location of the tangent point over the Earth that is located on the line of sight that points to a star defined by its right ascension and declination coordinates.
native void | targetTangentSun (final SatId satId, long deriv, long iray, double freq) throws CfiError
| It computes the location of the tangent point over the Earth that is located on the line of sight that points to the Sun.
native void | targetTangentMoon (final SatId satId, long deriv, long iray, double freq) throws CfiError
| It computes the location of the tangent point over the Earth that is located on the line of sight that points to the Moon.
native void | targetStation (final SatId satId, long deriv, double geocLong, double geodLat, double geodAlt, double minLinkEl) throws CfiError
| It computes the most relevant observation parameters of the link between the satellite and a ground station.
native void | targetDRS (final SatId satId, long deriv, double[] drsPos, double[] drsVel) throws CfiError
| It computes the most relevant observation parameters of the link between the satellite and a Data Relay Satellite.
native void | targetGeneric (final SatId satId, long deriv, double[] targPos, double[] targVel, double[] targAcc) throws CfiError
| It allows the user to provide the target location (position and velocity) and later calculate extra results from it.
native void | targetReflected (final SatId satId, long deriv, double geodAlt, double deflectionNorth, double deflectionEast, long sourceType, double[] sourceParam) throws CfiError
| It allows the user to compute, from S/C position and attitude, and emitting source position, the point of reflection from the source towards the SC at a certain geodetic altitude.
native void | multiTargetInter (final SatId satId, long deriv, long interFlag, double losAz, double losEl, long numTarget, double[] geodAlt, double losAzRate, double losElRate, long iray, double freq) throws CfiError
| It computes the first or the second intersection points of the line of sight from the satellite with surfaces located at certain geodetic altitudes over the Earth.
native void | multiTargetTravelTime (final SatId satId, long deriv, double losAz, double losEl, long numTarget, double[] travelTime, double losAzRate, double losElRate, double travelTimeRate, long iray, double freq) throws CfiError
| It computes the points of the line or sight from the satellite at given travel times along the (curved) line of sight.
native TargetExtra | extraVector (long choice, long targetType, long targetNumber) throws CfiError
| It provides the following output parameters for target(s): target position, velocity and acceleration vectors, line of sight direction, range, travel time and their corresponding derivatives.
native TargetExtra | extraMain (long choice, long targetType, long targetNumber) throws CfiError
| It computes the extra parameter for the target(s) in input data structure.
native TargetExtra | extraAux (long choice, long targetType, long targetNumber) throws CfiError
| It computes auxiliary parameters for the target in input data structure.
native TargetExtra | extraTargetToSun (long choice, long targetType, long targetNumber, long iray, double freq) throws CfiError
| It computes extra parameters related to the pointing fromthe target in input data structure to the sun.
native TargetExtra | extraTargetToMoon (long choice, long targetType, long targetNumber, long iray, double freq) throws CfiError
| It computes extra parameters related to the pointing from the target in input data structure to the moon.
native TargetExtra | extraEfTarget (long choice, long targetType, long targetNumber, double freq) throws CfiError
| It computes the parameter for an Earth fixed target related to the target in input data structure.
native TargetExtra | extraSpecularReflection (long choice, long targetType, long targetNumber, double deflectionNorth, double deflectionEast) throws CfiError
| It calculates the direction of the specular reflection associated to a given target.
native SatId | satId ()
| Return satellite id.
native TargetIdData | getData () throws CfiError
| It gets target parameters.
native void | eq (final Target target)
| Copy operator.
## Public Attributes
long | numUserTarget
| Number of user defined targer calculated.
long | numLosTarget
| Number of Line Of Sight target calculated.

## Detailed Description

Class for target calculations.

## Constructor & Destructor Documentation

EECFI.Target.Target | ( | final Attitude | att,
|  | final DemId | dem,
|  | final AtmosId | atmos |
| ) |  |  | throws CfiError

Class constructor.

## Member Function Documentation

void EECFI.Target::eq | ( | final Target | target | ) |

Copy operator.

Parameters:

  | target | Target object to be copied.

Returns:
  Target object copy of the input object; the new object is completely independent from the input one.

TargetExtra EECFI.Target::extraAux | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber |
| ) |  |  | throws CfiError

It computes auxiliary parameters for the target in input data structure.

Parameters:

  | choice | Flag to select the extra results to be computed (TargetResAuxNameEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.

Returns:
  Results vector; components:
  [0] Radius of curvature in the look direction at the nadir of the target (Earth fixed CS) [m]
  [1] Distance from the nadir of the target to the satellite nadir (EF CS) [m]
  [2] Minimum distance from the nadir of the target to the ground track (EF CS) [m]
  [3] Distance from the SSP to the point located on the ground track that is at a minimum distance from the nadir of the target (EF CS) [m]
  [4] Mean Local Solar Time at target [decimal hour]
  [5] True Local Solar Time at target [decimal hour]
  [6] Right ascension at which the look direction from the satellite to the target points at target point (True of Date CS) [deg]
  [7] Declination at which the look direction from the satellite to the target points at target point (True of Date CS) [deg].
  Results rate vector; components:
  [0] Radius of curvature-rate in the look direction at the nadir of the target (Earth fixed CS) [m/s]
  [1] Distance-rate from the nadir of the target to the satellite nadir (EF CS) [m/s]
  [2] Distance-rate from the nadir of the target to the ground track (EF CS) [m/s]
  [3] Distance-rate from the SSP to the point located on the ground track that is at a minimum distance from the nadir of the target (EF CS) [m/s]
  [4-7] dummy
  [8] Northward component of the velocity relative to the Earth of the nadir of the target (Topocentric CS) [m/s]
  [9] Eastward component of the velocity relative to the Earth of the nadir of the target (Topocentric CS) [m/s]
  [10] Azimuth of the velocity relative to the Earth of the nadir of the target.(Topocentric CS) [deg]

Results rate rate vector; components:
[0] Radius of curvature-rate-rate in the look direction at the nadir of the target (Earth fixed CS) [m/s]
[1] Distance-rate-rate from the nadir of the target to the satellite nadir (EF CS) [m/s]
[2] Distance-rate-rate from the nadir of the target to the ground track (EF CS) [m/s]
[3] Distance-rate-rate from the SSP to the point located on the ground track that is at a minimum distance from the nadir of the target (EF CS) [m/s].

TargetExtra EECFI.Target::extraEfTarget | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the parameter for an Earth fixed target related to the target in input data structure.

Parameters:

  | choice | Flag to select the extra results to be computed (DerivPointingEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

Returns:
  Results rate and rate-rate vectors; components:
  [0] 2-way Doppler shift of the signal (Earth Fixed CS) [Hz]
  [1] Earthfixed target to satellite range-rate (EF CS) [m/s]
  [2] Earthfixed target to satellite azimuth-rate (EF CS) [deg/s]
  [3] Earthfixed target to satellite elevation-rate (EF CS) [deg/s]
  [4] Satellite to earthfixed target azimuth-rate (Topocentric CS) [deg/s]
  [5] Satellite to earthfixed target elevation-rate (Topocentric CS) [deg/s]
  [6] Satellite to earthfixed target azimuth-rate (Attitude Frame) [deg/s]
  [7] Satellite to earthfixed target elevation-rate (Attitude Frame) [deg/s].

TargetExtra EECFI.Target::extraMain | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber |
| ) |  |  | throws CfiError

It computes the extra parameter for the target(s) in input data structure.

Parameters:

  | choice | Flag to select the extra results to be computed (TargetResMainNameEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.

Returns:
  Results vector and rates; components:
  [0] Target geocentric longitude (EF CS) [deg]
  [1] Target geocentric latitude (EF CS) [deg]
  [2] Target geodetic latitude (EF CS) [deg]
  [3] Target geodetic altitude (EF CS) [deg]
  [4] Satellite to target azimuth (Topocentric CS) [deg]
  [5] Satellite to target elevation (Topocentric CS) [deg]
  [6] Satellite to target pointing: Azimuth (Attitude Frame) [deg]
  [7] Satellite to target pointing: Elevation (Attitude Frame) [deg]
  [8] Satellite to target pointing: Azimuth (Topocentric) [deg]
  [9] Satellite to target pointing: Elevation (Topocentric) [deg].

TargetExtra EECFI.Target::extraSpecularReflection | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber,
|  | double | deflectionNorth,
|  | double | deflectionEast |
| ) |  |  | throws CfiError

It calculates the direction of the specular reflection associated to a given target.

Parameters:

  | choice | Flag to select the extra results to be computed (DerivPointingEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.
  | deflectionNorth | North-South component of the vertical deflection [deg]. Allowed range: >=-90; <=90.
  | deflectionEast | East-West component of the vertical deflection [deg]. Allowed range: >=-90; <=90.

Returns:
  Results vector, rate-vector and rate-rate vector; components:
  [0] X coordinate of reflected pointing direction (EF CS) [m]
  [1] Y coordinate of reflected pointing direction (EF CS) [m]
  [2] Z coordinate of reflected pointing direction (EF CS) [m]
  [3] Azimuth of the reflected pointing direction (Topocentric CS) [deg]
  [4] Elevation of the reflected pointing direction (Topocentric CS) [deg]
  [5] Right ascension at which the reflected pointing direction points at target point (True of Date CS) [deg]
  [6] Declination at which the reflected pointing direction points at target point (True of Date CS) [deg].

TargetExtra EECFI.Target::extraTargetToMoon | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes extra parameters related to the pointing from the target in input data structure to the moon.

Parameters:

  | choice | Flag to select the extra results to be computed (DerivPointingEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

Returns:
  Results vector; components:
  [0] Target to Moon (centre) azimuth (Topocentric CS) [deg]
  [1] Target to Moon (centre) elevation (Topocentric CS) [deg]
  [2] Tangent altitude over the Earth in the target to Moon (centre) look direction (EF CS) [m]
  [3] Target to Moon visibility flag (- 1: Moon eclipsed by the Earth; +1: Moon in sight).
  Results rate vector; components:
  [0] Target to Moon (centre) azimuth-rate (Topocentric CS) [deg/s]
  [1] Target to Moon (centre) elevation-rate (Topocentric CS) [deg/s].
  Results rate rate vector; components:
  [0] Target to Moon (centre) azimuth-rate-rate (Topocentric CS) [deg/s2]
  [1] Target to Moon (centre) elevation-rate-rate (Topocentric CS) [deg/s2].

TargetExtra EECFI.Target::extraTargetToSun | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes extra parameters related to the pointing fromthe target in input data structure to the sun.

Parameters:

  | choice | Flag to select the extra results to be computed (DerivPointingEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

Returns:
  Results vector; components:
  [0] Target to Sun (centre) azimuth (Topocentric CS) [deg]
  [1] Target to Sun (centre) elevation (Topocentric CS) [deg]
  [2] Tangent altitude over the Earth in the target to Sun (centre) look direction (EF CS) [m]
  [3] Target to Sun visibility flag (- 1: Sun eclipsed by the Earth; +1: Sun in sight).
  Results rate vector; components:
  [0] Target to Sun (centre) azimuth-rate (Topocentric CS) [deg/s]
  [1] Target to Sun (centre) elevation-rate (Topocentric CS) [deg/s].
  Results rate rate vector; components:
  [0] Target to Sun (centre) azimuth-rate-rate (Topocentric CS) [deg/s2]
  [1] Target to Sun (centre) elevation-rate-rate (Topocentric CS) [deg/s2].

TargetExtra EECFI.Target::extraVector | ( | long | choice,
|  | long | targetType,
|  | long | targetNumber |
| ) |  |  | throws CfiError

It provides the following output parameters for target(s): target position, velocity and acceleration vectors, line of sight direction, range, travel time and their corresponding derivatives.

Parameters:

  | choice | Flag to select the extra results to be computed (DerivPointingEnum). Even though derivatives could be requested by user, they will not be calculated if the target was computed without derivatives (a warning is raised in this case).
  | targetType | Flag to select the type of target (TargetTypeEnum).
  | targetNumber | Target number.

Returns:
  Result vector and rates; components:
  [0] Target Position X (EF CS) [m]
  [1] Target Position Y (EF CS) [m]
  [2] Target Position Z (EF CS) [m]
  [3] Direction LOS X (EF CS) [m]
  [4] Direction LOS X (EF CS) [m]
  [5] Direction LOS X (EF CS) [m]
  [6] Range to Attitude Frame Origin [m]
  [7] Travel Time to Attitude Frame Origin [s].

TargetIdData EECFI.Target::getData | ( |  | ) | throws CfiError

It gets target parameters.

Returns:
  Data of target id.

void EECFI.Target::multiTargetInter | ( | final SatId | satId,
|  | long | deriv,
|  | long | interFlag,
|  | double | losAz,
|  | double | losEl,
|  | long | numTarget,
|  | double[] | geodAlt,
|  | double | losAzRate,
|  | double | losElRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the first or the second intersection points of the line of sight from the satellite with surfaces located at certain geodetic altitudes over the Earth.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | interFlag | Flag for first or second intersection point selection (XPCFI_INTER_1ST or XPCFI_INTER_2ND).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | losEl | Elevation of the LOS (Attitude frame) [deg]. Allowed range: >=-90; <=90.
  | numTarget | Number of user defined altitudes.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | losElRate | Elevation rate of the LOS (Attitude frame) [deg/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::multiTargetTravelTime | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | losEl,
|  | long | numTarget,
|  | double[] | travelTime,
|  | double | losAzRate,
|  | double | losElRate,
|  | double | travelTimeRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the points of the line or sight from the satellite at given travel times along the (curved) line of sight.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | losEl | Elevation of the LOS (Attitude frame) [deg]. Allowed range: >=-90; <=90.
  | numTarget | Number of user defined altitudes.
  | travelTime | Travel time along the (curved) line of sight [s]. Allowed range: >0.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | losElRate | Elevation rate of the LOS (Attitude frame) [deg/s].
  | travelTimeRate | Travel time rate along the (curved) line of sight [s/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

SatId EECFI.Target::satId | ( |  | ) |

Return satellite id.

Returns:
  Satellite id.

void EECFI.Target::targetAltitude | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | geodAlt,
|  | double | losAzRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the location of the tangent point over the Earth that is located on a surface at a certain geodetic altitude over the Earth and that is on a line of sight that forms a certain azimuth angle in the selected Attitude Frame.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::targetDRS | ( | final SatId | satId,
|  | long | deriv,
|  | double[] | drsPos,
|  | double[] | drsVel |
| ) |  |  | throws CfiError

It computes the most relevant observation parameters of the link between the satellite and a Data Relay Satellite.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | drsPos | DRS position vector (Earth Fixed CS) [m].
  | drsVel | DRS velocity vector (Earth Fixed CS) [m/s].

void EECFI.Target::targetGeneric | ( | final SatId | satId,
|  | long | deriv,
|  | double[] | targPos,
|  | double[] | targVel,
|  | double[] | targAcc |
| ) |  |  | throws CfiError

It allows the user to provide the target location (position and velocity) and later calculate extra results from it.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | targPos | Target position vector (Earth Fixed CS) [m].
  | targVel | Target velocity vector (Earth Fixed CS) [m/s].
  | targAcc | Target acceleration vector (Earth Fixed CS) [m/s2].

void EECFI.Target::targetGroundRange | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | losEl,
|  | double | geodAlt,
|  | double | distance,
|  | double | losAzRate,
|  | double | losElRate |
| ) |  |  | throws CfiError

It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth, that lays on the plane defined by the satellite position, the nadir and a reference point.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | losEl | Elevation of the LOS (Attitude frame) [deg]. Allowed range: >=-90; <=90.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | distance | Distance or ground range to the reference point, positive from nadir in the azimuth direction (Earth Fixed CS) [m].
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | losElRate | Elevation rate of the LOS (Attitude frame) [deg/s].

void EECFI.Target::targetIncidenceAngle | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | incidenceAngle,
|  | double | geodAlt,
|  | double | losAzRate |
| ) |  |  | throws CfiError

It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth and that is seen from the satellite on a line of sight that forms a certain azimuth angle in the selected Attitude Frame and that intersects that surface with a certain incidence angle.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | incidenceAngle | Incidence angle of the LOS [deg]. Allowed range: >=0; <=90.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].

void EECFI.Target::targetInter | ( | final SatId | satId,
|  | long | deriv,
|  | long | interFlag,
|  | double | losAz,
|  | double | losEl,
|  | double | geodAlt,
|  | double | losAzRate,
|  | double | losElRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

Compute the first or the second intersection point of the line of sight from the satellite with a surface located at a certanin geodetic altitude over the Earth.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | interFlag | Flag for first or second intersection point selection (XPCFI_INTER_1ST or XPCFI_INTER_2ND).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | losEl | Elevation of the LOS (Attitude frame) [deg]. Allowed range: >=-90; <=90.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | losElRate | Elevation rate of the LOS (Attitude frame) [deg/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::targetRange | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | range,
|  | double | geodAlt,
|  | double | losAzRate,
|  | double | rangeRate |
| ) |  |  | throws CfiError

It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth, that is seen from the satellite on a line of sight that forms a certain azimuth angle in the selected Attitude Frame, and that is at a certain range or slant-range from the satellite.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | range | Range to the satellite (Earth Fixed CS) [m]. Allowed range: >0.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | rangeRate | Range rate to the satellite (Earth Fixed CS) [m/s].

void EECFI.Target::targetRangeRate | ( | final SatId | satId,
|  | long | deriv,
|  | double | efRangeRate,
|  | double | range,
|  | double | geodAlt,
|  | double | efRangeRateRate,
|  | double | rangeRate |
| ) |  |  | throws CfiError

It computes the location of a point that is placed on a surface at a certain geodetic altitude over the Earth, that is at a certain range from the satellite, and whose associatedEarth-fixed target has a certain range-rate value.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | efRangeRate | Range rate of the related Earth-Fixed target (Earth Fixed CS) [m/s].
  | range | Range to the satellite (Earth Fixed CS) [m]. Allowed range: >0.
  | geodAlt | Geodetic altitude over the Earth [m]. Allowed range: >=-bWGS.
  | efRangeRateRate | Range rate rate of the related Earth-Fixed target (Earth Fixed CS) [m/s2].
  | rangeRate | Range rate to the satellite (Earth Fixed CS) [m/s].

void EECFI.Target::targetReflected | ( | final SatId | satId,
|  | long | deriv,
|  | double | geodAlt,
|  | double | deflectionNorth,
|  | double | deflectionEast,
|  | long | sourceType,
|  | double[] | sourceParam |
| ) |  |  | throws CfiError

It allows the user to compute, from S/C position and attitude, and emitting source position, the point of reflection from the source towards the SC at a certain geodetic altitude.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | geodAlt | Geodetic altitude (Earth Fixed CS) [deg]. Allowed range: >=-90; <=90.
  | deflectionNorth | North-South component of the vertical deflection [deg]. Allowed range: >=-90; <=90.
  | deflectionEast | East-West component of the vertical deflection [deg]. Allowed range: >=-90; <=90.
  | sourceType | Type of the source (SourceTypeEnum).
  | sourceParam | Vector with parameters (depends on sourceType). if source_type is XPCFI_SRC_STAR is selected, source_param = [ra (deg), dec (deg), parallax, 0.0, 0.0, 0.0], i.e. star coordinates in BM2000 CS. if source_type is XPCFI_SOURCE_GENERIC source_param = [x, y, z, vx,vy,vz] position and velocity in EF else dummy values. .

void EECFI.Target::targetStar | ( | final SatId | satId,
|  | long | deriv,
|  | double | starRa,
|  | double | starDec,
|  | double | starRaRate,
|  | double | starDecRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the location of the tangent point over the Earth that is located on the line of sight that points to a star defined by its right ascension and declination coordinates.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | starRa | Right ascension of the star (True of Date CS) [deg]. Allowed range: >=0; <360.
  | starDec | Declination of the star (True of Date CS) [deg]. Allowed range: >=-90; <=90.
  | starRaRate | Right ascension of the star rate (True of Date CS) [deg/s].
  | starDecRate | Declination of the star rate (True of Date CS) [deg/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::targetStation | ( | final SatId | satId,
|  | long | deriv,
|  | double | geocLong,
|  | double | geodLat,
|  | double | geodAlt,
|  | double | minLinkEl |
| ) |  |  | throws CfiError

It computes the most relevant observation parameters of the link between the satellite and a ground station.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | geocLong | GS geocentric longitude (Earth Fixed CS) [deg]. Allowed range: >=0; <360.
  | geodLat | GS geodetic latitude (Earth Fixed CS) [deg]. Allowed range: >=-90; <=90.
  | geodAlt | GS Geodetic altitude (Earth Fixed CS) [m]. Allowed range: >=-bWGS.
  | minLinkEl | GS minimum link elevation (Topocentric CS) [deg]. Allowed range: >=-90; <=90.

void EECFI.Target::targetTangent | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | losEl,
|  | double | losAzRate,
|  | double | losElRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the location of the tangent point over the Earth that is located on the line of sight defined by an elevation and azimuth angles expressed in the selected Attitude Frame.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | losEl | Elevation of the LOS (Attitude frame) [deg]. Allowed range: >=-90; <=90.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | losElRate | Elevation rate of the LOS (Attitude frame) [deg/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::targetTangentMoon | ( | final SatId | satId,
|  | long | deriv,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the location of the tangent point over the Earth that is located on the line of sight that points to the Moon.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::targetTangentSun | ( | final SatId | satId,
|  | long | deriv,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the location of the tangent point over the Earth that is located on the line of sight that points to the Sun.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

void EECFI.Target::targetTravelTime | ( | final SatId | satId,
|  | long | deriv,
|  | double | losAz,
|  | double | losEl,
|  | double | travelTime,
|  | double | losAzRate,
|  | double | losElRate,
|  | double | travelTimeRate,
|  | long | iray,
|  | double | freq |
| ) |  |  | throws CfiError

It computes the point of the line or sight from the satellite at a given travel time along the line of sight.

Parameters:

  | satId | Satellite id.
  | deriv | Derivative order (DerivPointingEnum).
  | losAz | Azimuth of the LOS (Attitude frame) [deg]. Allowed range: >=0; <360.
  | losEl | Elevation of the LOS (Attitude frame) [deg]. Allowed range: >=-90; <=90.
  | travelTime | Travel time along the (curved) line of sight [s]. Allowed range: >0.
  | losAzRate | Azimuth rate of the LOS (Attitude frame) [deg/s].
  | losElRate | Elevation rate of the LOS (Attitude frame) [deg/s].
  | travelTimeRate | Travel time rate along the (curved) line of sight [s/s].
  | iray | Ray tracing model switch (not used).
  | freq | Frequency of the signal [Hz]. Allowed range: >0.

## Member Data Documentation

long EECFI.Target.numLosTarget

Number of Line Of Sight target calculated.

long EECFI.Target.numUserTarget

Number of user defined targer calculated.